
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GoalsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const goals = await db.goals.create(
            {
                id: data.id || undefined,
        
        goal_type: data.goal_type
        ||
        null
            ,
            
        follow_up_answer: data.follow_up_answer
        ||
        null
            ,
            
        target_date: data.target_date
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await goals.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return goals;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const goalsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                goal_type: item.goal_type
            ||
            null
            ,
            
                follow_up_answer: item.follow_up_answer
            ||
            null
            ,
            
                target_date: item.target_date
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const goals = await db.goals.bulkCreate(goalsData, { transaction });

        // For each item created, replace relation files
        

        return goals;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const goals = await db.goals.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.goal_type !== undefined) updatePayload.goal_type = data.goal_type;
        
        
        if (data.follow_up_answer !== undefined) updatePayload.follow_up_answer = data.follow_up_answer;
        
        
        if (data.target_date !== undefined) updatePayload.target_date = data.target_date;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await goals.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await goals.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return goals;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const goals = await db.goals.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of goals) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of goals) {
                await record.destroy({transaction});
            }
        });


        return goals;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const goals = await db.goals.findByPk(id, options);

        await goals.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await goals.destroy({
            transaction
        });

        return goals;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const goals = await db.goals.findOne(
            { where },
            { transaction },
        );

        if (!goals) {
            return goals;
        }

        const output = goals.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await goals.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.follow_up_answer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'goals',
                        'follow_up_answer',
                        filter.follow_up_answer,
                    ),
                };
            }
            

            
            

            
            if (filter.target_dateRange) {
                const [start, end] = filter.target_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    target_date: {
                    ...where.target_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    target_date: {
                    ...where.target_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.goal_type) {
                where = {
                    ...where,
                goal_type: filter.goal_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.goals.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'goals',
                        'follow_up_answer',
                        query,
                    ),
                ],
            };
        }

        const records = await db.goals.findAll({
            attributes: [ 'id', 'follow_up_answer' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['follow_up_answer', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.follow_up_answer,
        }));
    }

    
};

